#push功能的代理选择用哪种推送工具1.个推 2.小米 3.华为
class PushToolClient
  
  def initialize(opts={})
    opts = HashWithIndifferentAccess.new(opts)
    @user_ids = opts[:user_ids]
    @opts = opts
  end

  def do_push
    Settings.platform = @opts[:app_type] || Settings::DEFAULT
    @push_device_collections ||= UserDevice.where(user_id: @user_ids).group_by(&:platform)
    @igetui_push_device_collections ||= @push_device_collections['igetui'].group_by(&:device_platform) if @push_device_collections['igetui'].is_a? Array
    if @igetui_push_device_collections.is_a? Hash
      igetui_android_device_ids = @igetui_push_device_collections['android'].map(&:device_id) if @igetui_push_device_collections['android'].is_a? Array
      igetui_ios_device_ids = @igetui_push_device_collections['ios'].map(&:devendice_id) if @igetui_push_device_collections['ios'].is_a? Array
    end

    Igetui::Pusher.new(igetui_android_device_ids, @opts.merge(device_platform: 'android')).perform if igetui_android_device_ids.present?
    Igetui::Pusher.new(igetui_ios_device_ids, @opts.merge(device_platform: 'ios')).perform if igetui_ios_device_ids.present?

    #现在好像不用了
    # Push::IgetuiIos.push(@push_collections[:igetui_ios], @opts) if @push_collections[:apns].present?
    # Push::IgetuiAndroid.push(@push_collections[:igetui_android], @opts) if @push_collections[:apns].present?

    xiaomi_device_ids = @push_device_collections['xiaomi'].map(&:device_id) if @push_device_collections['xiaomi'].is_a? Array
    huawei_device_ids = @push_device_collections['huawei'].map(&:device_id) if @push_device_collections['huawei'].is_a? Array

    Xiaomi::Pusher.new(xiaomi_device_ids, @opts[:message]).perform if xiaomi_device_ids.present?
    Huawei::Pusher.new(huawei_device_ids, @opts[:message]).perform if huawei_device_ids.present?
  end
end